<?php

/**
 * @package     Joomla.Plugin
 * @subpackage  Unofficial Content.joomgallery for Alpha version
 *
 * @copyright   (C) 2018 Open Source Matters, Inc. <https://www.joomla.org>
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

namespace Joomla\Plugin\Content\Joomplualpha\Extension;

use Joomla\CMS\Factory;
use Joomla\CMS\Plugin\CMSPlugin;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\Registry\Registry;
use Joomla\CMS\Document\HtmlDocument;
use Joomla\CMS\HTML\HTMLHelper;

// phpcs:disable PSR1.Files.SideEffects
\defined('_JEXEC') or die;
// phpcs:enable PSR1.Files.SideEffects

/**
 * Joomplualpha content plugin
 *
 * @since  4.4.4
 */


// checkACL gag function
class acls {
    private $acl;

    public function setWebAssetManager(callable $webAssetManager) {
        return true;
    }

    public function checkACL($type,$context,$id,$bo=true) {
        if (isset($this->acl)) {
            return call_user_func($this->webAssetManager, $arg);
        } 
    }
}


final class Joomplualpha extends CMSPlugin
{
  public $document;
  public $acl;

    // gag functions
    public function getLayout() {return 'default';}
    public function escape($title) {return $title;}


    public function onContentPrepare($context, &$article, $params, $page = 0)
    {




        $allowed_contexts = ['com_content.article'];
        if (!in_array($context, $allowed_contexts)) 
            return;


	$regex_cat  = '/{joomplucat:([0-9]+)(.*)}/';//([a-z,=,",|, ]*)
        if(preg_match_all($regex_cat, $article->text, $matches, PREG_SET_ORDER))
        {
 	 $catid   = (int) $matches[0][1];
	 $columns = (int) explode('columns=',$matches[0][2])[1];



         
	 if (is_int($catid) && isset($matches[0][0]))
	  {


		$app = Factory::getApplication();
		$layout 			= $this->params->get('jg_layout');
		$layout_overide 		= $this->params->get('jg_layout_overide');
		$jg_category_view_num_columns 	= $this->params->get('jg_category_view_num_columns');
		$jg_category_view_caption_align	= $this->params->get('jg_category_view_caption_align');
		$jg_lightbox 			= $this->params->get('jg_lightbox');
		$category_class == 'justified';

		// boot com_joomgallery
		$joomg = $app->bootComponent('com_joomgallery')->getMVCFactory();

		// get category model
		$category = $joomg->createModel('category', 'site');
		$category->setState('category.id', $catid);
	        $this->item = new \stdClass();
		$this->item = $category->getItem($catid);
	
	        $this->item->images = new \stdClass();
		$this->item->images->items = $category->getImages();
		$this->item->images->pagination    = $category->getImagesPagination();
	        $this->item->children = new \stdClass();
		$this->item->children->items = [];
		$this->item->parent_id = null;




		// set some config options
		$config = $app->getConfig();
		$config->set('menu', new Registry((object) [
		    'save_history' => 0,
		    'show_page_heading' => 0,
		    'jg_category_view_class' => 'columns',
		    'jg_category_view_num_columns' => $jg_category_view_num_columns,
		    'jg_category_view_caption_align' => $jg_category_view_caption_align,
		    'jg_category_view_justified_height' => 120,
		    'jg_category_view_justified_gap' => 0,
		    'jg_category_view_lightbox' => $jg_lightbox,
	
		    'menu-anchor_title' => '',
		    'menu-anchor_css' => '',
		    'menu_icon_css' => '',
		    'menu_image' => '',
		    'menu_image_css' => '',
		    'menu_text' => 1,
		    'menu_show' => 1
		]));

	        $this->params = $config;
		$config = $app->getConfig();

		// add joomgallery js/css asset
		$wa = Factory::getApplication()->getDocument()->getWebAssetManager();
		$wr = $wa->getRegistry();
		$wr->addRegistryFile('/media/com_joomgallery/joomla.asset.json');

		$this->acl = new acls();
		$this->document  = Factory::getApplication()->getDocument();
	
		ob_start();
		if ($layout_overide==0)
	  	 require(JPATH_SITE . '/components/com_joomgallery/tmpl/category/default.php');

		if ($layout_overide==1)
  		 require(JPATH_SITE . '/templates/'.$app->getTemplate().'/html/com_joomgallery/category/default.php');
		$output = ob_get_clean();


		$output = str_replace("<h3>Images</h3>",'',$output);
		$output = str_replace("<h2>COM_JOOMGALLERY</h2>",'',$output);
		$article->text =str_replace($matches[0][0],$output,$article->text);
		ob_clean();


  	    }
       }
    			
     }


}

